﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace InChatter.Client.Service
{
    public class ChatMsgCenter
    {
        private static Lazy<ChatMsgCenter> _Instance = new Lazy<ChatMsgCenter>();

        public static ChatMsgCenter Instance
        {
            get
            {
                return _Instance.Value;
            }
        }

        public string DbUrl { set; get; }

        public ChatServer.ChatClient Client { set; get; }

        private ChatCallback callback { set; get; }

        public event Action<ChatServer.InChatterMessage> OnMessageReceived;

        public event Action<Messager> OnUnReadMessageRead;

        private ChatMsgCenter()
        {
            callback = new ChatCallback();
            Client = new ChatServer.ChatClient(new System.ServiceModel.InstanceContext(callback), "NetTcpBinding_IChat");
            callback.OnMessgeReceived+=callback_OnMessgeReceived;
        }

        private void callback_OnMessgeReceived(ChatServer.InChatterMessage message)
        {
            Messager msg = new Messager()
            {
                IsRead = false,
                Message = message,
            };
            DataHelper.Save(msg);
            if (OnMessageReceived != null)
            {
                OnMessageReceived(message);
            }
        }

        public void Login(string clientId)
        {
            Client.Login(clientId);
            DbUrl = "Messages\\"+clientId+".db";
        }

        public void SendMsg(ChatServer.InChatterMessage message)
        {
            Messager msg = new Messager()
            {
                IsRead = true,
                Message = message,
            };
            DataHelper.Save(msg);
            Client.SendMsg(msg.Message);
        }

        public void Logout(string clientId)
        {
            Client.Logout(clientId);
        }
    }
}
