﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace InChatter.Client.Service
{
    public class DataHelper
    {
        #region Save
        public static bool Save(Messager message)
        {
            try
            {
                lock (string.Intern(ChatMsgCenter.Instance.DbUrl))
                {
                    using (var db = NDatabase.OdbFactory.Open(ChatMsgCenter.Instance.DbUrl))
                    {
                        db.Store(message);
                    }
                }
                return true;
            }
            catch
            {
                return false;
            }
        }

        public static bool Save(IEnumerable<Messager> msgList)
        {
            try
            {
                lock (string.Intern(ChatMsgCenter.Instance.DbUrl))
                {
                    using (var db = NDatabase.OdbFactory.Open(ChatMsgCenter.Instance.DbUrl))
                    {
                        foreach (var msg in msgList)
                        {
                            db.Store(msg);
                        }
                    }
                }
                return true;
            }
            catch
            {
                return false;
            }
        }
        #endregion

        public static bool Update(Messager message)
        {
            try
            {
                lock (string.Intern(ChatMsgCenter.Instance.DbUrl))
                {
                    using (var db = NDatabase.OdbFactory.Open(ChatMsgCenter.Instance.DbUrl))
                    {
                        var msg = (from item in db.AsQueryable<Messager>()
                                   where item.Id == message.Id
                                   select item).Single();
                        msg.IsRead = message.IsRead;
                        msg.Message = message.Message;
                        db.Store(msg);
                    }
                }
                return true;
            }
            catch
            {
                return false;
            }
        }

        public static bool Delete(string msgId)
        {
            try
            {
                lock (string.Intern(ChatMsgCenter.Instance.DbUrl))
                {
                    using (var db = NDatabase.OdbFactory.Open(ChatMsgCenter.Instance.DbUrl))
                    {
                        var msg = (from item in db.AsQueryable<Messager>()
                                   where item.Id == msgId
                                   select item).Single();
                        db.Delete(msg);
                    }
                }
                return true;
            }
            catch
            {
                return false;
            }
        }
    }
}
